require "util"
local function create_pack(name,icon,repeat_count)
    local capsule=table.deepcopy(data.raw.capsule[name])
    capsule.name=name.."-pack"
    capsule.icon=icon
    capsule.capsule_action.attack_parameters.ammo_type.action.repeat_count = repeat_count
    capsule.capsule_action.attack_parameters.ammo_type.action.action_delivery.direction_deviation = 0.5
    capsule.capsule_action.attack_parameters.ammo_type.action.action_delivery.range_deviation = 0.5
    return capsule
end

local defender_pack =create_pack("defender-capsule","__Encapsulation__/defender-capsule-pack.png",10)
local destroyer_pack =create_pack("destroyer-capsule","__Encapsulation__/destroyer-capsule-pack.png",6)
local destroyer_megapack =create_pack("destroyer-capsule","__Encapsulation__/destroyer-capsule-megapack.png",27)
destroyer_megapack.name="destroyer-capsule-megapack"
local defender_pack_recipe={
    type = "recipe",name = "defender-capsule-pack",enabled = false,
    energy_required = 8,
    ingredients ={
      {"defender-capsule", 10},
      {"electronic-circuit", 1},
    },
    result = "defender-capsule-pack"
}
local destroyer_pack_recipe={
    type = "recipe",name = "destroyer-capsule-pack",enabled = false,
    energy_required = 8,
    ingredients ={
      {"destroyer-capsule", 6},
      {"advanced-circuit", 1},
    },
    result = "destroyer-capsule-pack"
}

local destroyer_megapack_recipe={
    type = "recipe",name = "destroyer-capsule-megapack",enabled = false,
    energy_required = 8,
    ingredients ={
      {"destroyer-capsule-pack", 4},
      {"destroyer-capsule", 5},
      {"processing-unit", 1},
    },
    result = "destroyer-capsule-megapack"
}
local defender_pack_technology={
    type = "technology",
    name = "defender-capsule-pack",
    icon = "__Encapsulation__/defender-capsule-pack.png",
    effects ={
        {type = "unlock-recipe",recipe = "defender-capsule-pack"}
    },
    prerequisites = {"follower-robot-count-6"},
    unit ={count = 20,ingredients = {{"science-pack-1", 1,},{"science-pack-2", 1}},time = 5},
    order ="e-p-a-b"
  }
local destroyer_pack_technology={
    type = "technology",
    name = "destroyer-capsule-pack",
    icon = "__Encapsulation__/destroyer-capsule-pack.png",
    effects ={
        {type = "unlock-recipe",recipe = "destroyer-capsule-pack"}
    },
    prerequisites = {"combat-robotics-3","follower-robot-count-10"},
    unit ={count = 20,ingredients = {{"science-pack-1", 1,},{"science-pack-2", 1},{"science-pack-3", 1}},time = 5},
    order ="e-p-b-b"
  }
local destroyer_megapack_technology={
    type = "technology",
    name = "destroyer-capsule-megapack",
    icon = "__Encapsulation__/destroyer-capsule-megapack.png",
    effects ={
        {type = "unlock-recipe",recipe = "destroyer-capsule-megapack"}
    },
    prerequisites = {"destroyer-capsule-pack","follower-robot-count-20"},
    unit ={count = 20,ingredients = {{"science-pack-1", 1,},{"science-pack-2", 1},{"science-pack-3", 1},{"alien-science-pack", 1}},time = 5},
    order ="e-p-b-c"
  }
data:extend({
    defender_pack,
    destroyer_pack,
    destroyer_megapack,
    defender_pack_recipe,
    destroyer_pack_recipe,
    defender_pack_technology,
    destroyer_pack_technology,
    destroyer_megapack_recipe,
    destroyer_megapack_technology,
    })
